#include<bits/stdc++.h>
using namespace std;
int t,n,m,a[75005],b[75005],resenje;
long long x;
int main()
{
    cin>>t;
    for(int g=1; g<=t; g++){
        cin>>n>>m;
        for(int i=1; i<=n; i++)
            cin>>a[i];
        for(int i=1; i<=m; i++)
            cin>>b[i];

        sort(a+1, a+n+1);
        x=a[2]-a[1];

        for(int i=1; i<=n; i++){
            if(a[i+1]-a[i]!=x){
                    resenje = 0;
                    break;
            }
            else{
                resenje = 1;
            }
        }
        for(int i=1; i<=m; i++){
            if((b[i]-a[1])%x==0){
                resenje = 0;
                break;
            }
            else{
                resenje = 1;
            }
        }
        cout<<resenje<<endl;
    }
    return 0;
}